`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2019/03/09 16:55:11
// Design Name: 
// Module Name: topmodule
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module topmodule(
    segs,
    ssd_ctl,
    clk,
    rst_n
    );

    output [7:0] segs;
    output [3:0] ssd_ctl;
    input clk;
    input rst_n;
    
    wire clk_divided_1Hz;
    wire [1:0] clk_ssd; 

    wire [2:0] out_tmp_0;
    wire [2:0] out_tmp_1;
    wire [2:0] out_tmp_2;
    wire [2:0] out_tmp_3;

    wire [2:0] ssd_in_tmp;

    freqdiv U0(
    .clk_out(clk_divided_1Hz), //divided clock output
    .clk_ctl(clk_ssd), //clock for 7-segment
    .clk(clk),    //clock input
    .rst_n(rst_n)   //low-active reset
);
    shifter U1(
    .out_0(out_tmp_0),
    .out_1(out_tmp_1),
    .out_2(out_tmp_2),
    .out_3(out_tmp_3),
    .clk(clk_divided_1Hz),
    .rst_n(rst_n)
);
    scan_freq_ctl U2(
    .ssd_in(ssd_in_tmp),
    .ssd_ctl(ssd_ctl),
    .in_0(out_tmp_0),
    .in_1(out_tmp_1),
    .in_2(out_tmp_2),
    .in_3(out_tmp_3),
    .clk_ctl_en(clk_ssd),
    .rst_n(rst_n)
);
    ssd_display U3(
    .segs(segs),
    .in(ssd_in_tmp)
);
    
endmodule
